//*****************************************************************
// 
//  JAVA Source for com.idautomation.databar; 2010
//  
//	 Copyright IDAutomation.com, Inc. All rights reserved.
//	Redistribution and use of this code in source and/or binary 
//	forms, with or without modification, are permitted provided 
//	that: (1) all copies of the source code retain the above 
//	unmodified copyright notice and this entire unmodified 
//	section of text, (2) You or Your organization owns a valid 
//	Developer License to this product from IDAutomation.com 
//	and, (3) when any portion of this code is bundled in any 
//	form with an application, a valid notice must be provided 
//	within the user documentation, start-up screen or in the 
//	help-about section of the application that specifies 
//	IDAutomation.com as the provider of the Software bundled 
//	with the application.
//*****************************************************************

package com.idautomation.databar;

class SpecialStringFunctions 
{
    protected String PadLeft(String retStr, int Len, char InsertedChar)
    {
        if (retStr.length() >= Len)
            return retStr;
        else
        {
            String LeadingStr = "";
            int NumOfChars = Len - retStr.length();
            for(int x = 0; x < NumOfChars; x++)
                LeadingStr += InsertedChar;
            return LeadingStr + retStr;
        }
    }
    protected String PadRight(String retStr, int Len, char AppendedChar)
    {			
        if (retStr.length() >= Len)
            return retStr;
        else
        {
            String LeadingStr = "";
            int NumOfChars = Len - retStr.length();
            for(int x = 0; x < NumOfChars; x++)
            {
                retStr += AppendedChar;
            }
            return retStr;
        }
    }
    protected String Reverse(String str)
    {
        // convert the string to char array
        char[] charArray = str.toCharArray();
        int len = str.length() - 1;
        /*
        now this for is a bit unconventional at first glance because there
        are 2 variables that we're changing values of: i++ and len--.
        the order of them is irrelevant. so basicaly we're going with i from 
        start to end of the array. with len we're shortening the array by one
        each time. this is probably understandable.
        */
        for (int i = 0; i < len; i++, len--)
        {
            /*
            now this is the tricky part people that should know about it don't.
            look at the table below to see what's going on exactly here.
            */
            charArray[i] ^= charArray[len];
            charArray[len] ^= charArray[i];
            charArray[i] ^= charArray[len];
        }
        return new String(charArray);
    }
}
